/****************************************************************************
* MeshLab                                                           o o     *
* A versatile mesh processing toolbox                             o     o   *
*                                                                _   O  _   *
* Copyright(C) 2005                                                \/)\/    *
* Visual Computing Lab                                            /\/|      *
* ISTI - Italian National Research Council                           |      *
*                                                                    \      *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *   
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/
/****************************************************************************
  History
$Log: saveSnapshotDialog.h,v $
Revision 1.2  2005/12/06 10:42:03  vannini
Snapshot dialog now works

Revision 1.1  2005/12/05 18:15:27  vannini
Added snapshot save dialog (not used yet)


****************************************************************************/

#include "ui_savesnapshot.h"
#include "glarea.h"
#include <QDialog>
#include <QFileDialog>

class SaveSnapshotDialog: public QDialog
{
Q_OBJECT

public:
	SaveSnapshotDialog(QWidget *parent = 0);
	void SaveSnapshotDialog::setValues(const SnapshotSetting &ss);
	SnapshotSetting SaveSnapshotDialog::getValues();
	
private slots:
	void browseDir();

private:
	Ui::SSDialog ui;
	SnapshotSetting settings;
};
