/****************************************************************************
* MeshLab                                                           o o     *
* A versatile mesh processing toolbox                             o     o   *
*                                                                _   O  _   *
* Copyright(C) 2005                                                \/)\/    *
* Visual Computing Lab                                            /\/|      *
* ISTI - Italian National Research Council                           |      *
*                                                                    \      *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *   
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/
/****************************************************************************
  History
$Log: meshrender.h,v $
Revision 1.5  2005/12/05 18:11:28  ggangemi
Added toon shader example

Revision 1.4  2005/12/05 16:52:57  ggangemi
new interfaces

Revision 1.3  2005/12/03 22:50:06  cignoni
Added copyright info

****************************************************************************/

#ifndef SHADERRENDERPLUGIN_H
#define SHADERRENDERPLUGIN_H

#include <QObject>
#include <QAction>
#include <QList>

#include <gl/glew.h>
#include <meshlab/meshmodel.h>
#include <meshlab/interfaces.h>

class MeshShaderRenderPlugin : public QObject, public MeshRenderInterface
{
  Q_OBJECT
  Q_INTERFACES(MeshRenderInterface)

	GLhandleARB p;
	GLhandleARB v;
	GLhandleARB f;

	GLint edge;  
	GLint phong; 
	GLint diffuseColor;
	GLint phongColor;

	bool supported;
	QList <QAction *> actionList;

public:
     
	MeshShaderRenderPlugin()
	{
		supported = false;
		actionList << new QAction(QString("Toon Shader"),this);
	}

	QList<QAction *> actions () const {return actionList;}

	virtual bool isSupported() {return supported;}
	virtual void Init(QAction *a, MeshModel &m, GLArea *gla);
  virtual void Render(QAction *a, MeshModel &m, RenderMode &rm, GLArea *gla);

};

#endif

